VERSION 5.00
Begin VB.Form frmRng 
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   9330
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   13395
   Icon            =   "frmRng.frx":0000
   LinkTopic       =   "Form1"
   Picture         =   "frmRng.frx":030A
   ScaleHeight     =   622
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   893
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.PictureBox PicView 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   5055
      Left            =   0
      Picture         =   "frmRng.frx":2933B
      ScaleHeight     =   335
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   341
      TabIndex        =   0
      Top             =   0
      Width           =   5145
   End
   Begin VB.Timer tmrRoll 
      Interval        =   60
      Left            =   9045
      Top             =   540
   End
End
Attribute VB_Name = "frmRng"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type POINTAPI
   x As Long
   y As Long
End Type

Private Declare Function SetWindowPos& Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long
Private ResultRegion As Long

Private PolyPoints(4) As POINTAPI

'Constantes pour CombineRgn
Private Const RGN_AND = 1        'Intersection des deux rgions
Private Const RGN_OR = 2         'Addition des deux rgions
Private Const RGN_XOR = 3        'Difficile  dcrire ... essayez
'En fait, c'est un XOR : l'addition des 2 rgions
'en retirant les parties communes aux 2 rgions
Private Const RGN_DIFF = 4       'Soustraction de la rgion 2  la rgion 1
Private Const RGN_COPY = 5       'Copie la rgion 1
Private Const HWND_TOPMOST = -1

Const PI As Single = 3.14


Private Function RoolIT()
    Dim nRet As Long
    Const RD As Single = 350
    Const ANG_SIZE As Integer = 50
    Const SPEED As Integer = 20
    Static Rolling As Single
    nRet = SetWindowRgn(PicView.hwnd, CreateFormRegion(Rolling, ANG_SIZE, RD, 100, 30), True)
    nRet = SetWindowRgn(Me.hwnd, CreateFormFrame(RD - 5, 0, 0), True)
    Rolling = Rolling + SPEED
    If (Rolling) > 360 Then Rolling = 0
End Function

Public Sub TriAngl(ByVal vAng1 As Single, vAng2 As Single, _
                    ByVal vOffsetX As Single, ByVal vOffestY As Single, _
                    ByVal vR As Single)
    Dim KerenAng As Single
    Dim yeter As Single
    Dim b2 As Single
    Dim q As Single
    Dim n As Single
    Dim m As Single
        
    PolyPoints(0).x = vOffsetX
    PolyPoints(0).y = vOffestY
    
    PolyPoints(0).x = vOffsetX + vR
    PolyPoints(0).y = vOffestY + vR
    
    PolyPoints(1).x = (Sin(vAng1 * (PI / 180)) * vR) + PolyPoints(0).x
    PolyPoints(1).y = (Cos(vAng1 * (PI / 180)) * (-1) * vR) + PolyPoints(0).y
    
    PolyPoints(4).x = (Sin((vAng1 + vAng2) * (PI / 180)) * vR) + PolyPoints(0).x
    PolyPoints(4).y = (Cos((vAng1 + vAng2) * (PI / 180)) * (-1) * vR) + PolyPoints(0).y
    
    
    KerenAng = vAng1 + (vAng2 / 2)
    PolyPoints(3).x = (Sin((KerenAng) * (PI / 180)) * vR) + PolyPoints(4).x
    PolyPoints(3).y = (Cos((KerenAng) * (PI / 180)) * (-1) * vR) + PolyPoints(4).y
    
    PolyPoints(2).x = (Sin((KerenAng) * (PI / 180)) * vR) + PolyPoints(1).x
    PolyPoints(2).y = (Cos((KerenAng) * (PI / 180)) * (-1) * vR) + PolyPoints(1).y
End Sub


Private Function CreateFormRegion(Ang As Single, angOffsett As Single, Radius As Single, _
                            OffsetX As Integer, OffsetY As Integer) As Long
    Dim Corraction As Integer
    Dim HolderRegion As Long, ObjectRegion As Long, nRet As Long
    Dim i As Integer
    
    ResultRegion = CreateRectRgn(0, 0, 0, 0)
    
    'set the rgn
    Call TriAngl(Ang, angOffsett, OffsetX, OffsetY, Radius)
    
    
    ObjectRegion = CreatePolygonRgn(PolyPoints(0), 5, 1)

    HolderRegion = CreateEllipticRgn(PolyPoints(0).x - Radius, PolyPoints(0).y - Radius, _
                                    PolyPoints(0).x + Radius, PolyPoints(0).y + Radius)
            
    nRet = CombineRgn(ResultRegion, HolderRegion, ObjectRegion, RGN_AND)
    
    DeleteObject ObjectRegion
    DeleteObject HolderRegion
    CreateFormRegion = ResultRegion
End Function

Private Function CreateFormFrame(ByVal Radius As Single, _
                ByVal OffsetX As Single, ByVal OffsetY As Single) As Long
    Dim Corraction As Integer
    Dim HolderRegion As Long, nRet As Long
    Dim i As Integer
    ResultRegion = CreateRectRgn(0, 0, 0, 0)
    
    
    HolderRegion = CreateEllipticRgn(PolyPoints(0).x - Radius + OffsetX, _
                                    PolyPoints(0).y - Radius + OffsetY, _
                                    PolyPoints(0).x + Radius + OffsetX, _
                                    PolyPoints(0).y + Radius + OffsetY)
    nRet = CombineRgn(ResultRegion, HolderRegion, HolderRegion, RGN_AND)
    
    DeleteObject HolderRegion
    CreateFormFrame = ResultRegion
End Function

Private Sub Form_Activate()
    SetWindowPos Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, 3
    RoolIT
End Sub

Private Sub Form_DblClick()
    Unload Me
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Next two lines enable window drag from anywhere on form.  Remove them
'to allow window drag from title bar only.
    ReleaseCapture
    SendMessage Me.hwnd, &HA1, 2, 0&
End Sub

Private Sub Form_Resize()
    PicView.Width = Me.Width
    PicView.Height = Me.Height
End Sub

Private Sub Form_Unload(Cancel As Integer)
    DeleteObject ResultRegion
    'If the above line is modified or moved a second copy of it
    'may be added again if the form is later Modified by VBSFC.
End Sub

Private Sub tmrRoll_Timer()
    RoolIT
End Sub
